/*
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/

 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.

 * The Original Code is Rhino code, released
 * May 6, 1999.

 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1997-1999 Netscape Communications Corporation. All
 * Rights Reserved.

 * Contributor(s): 

 * Alternatively, the contents of this file may be used under the
 * terms of the GNU Public License (the "GPL"), in which case the
 * provisions of the GPL are applicable instead of those above.
 * If you wish to allow use of your version of this file only
 * under the terms of the GPL and not to allow others to use your
 * version of this file under the NPL, indicate your decision by
 * deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL.  If you do not delete
 * the provisions above, a recipient may use your version of this
 * file under either the NPL or the GPL.
 */
/**
 * This class implements the Function native object.
 * See ECMA 15.3.
 */

#ifndef _JS_NATIVE_FUNCTION_H_
#define _JS_NATIVE_FUNCTION_H_

#include "js-scriptableobject.h"
#include "js-function.h"

/* Classes */
class JSNativeFunction: public JSScriptableObject, public JSFunction {
    friend class JSArguments;
    friend class JSNativeDate;
    friend class JSScriptRuntime;
    friend class JSNativeCall;

    protected:
	static const int OFFSET = 4;
	static const int SETBACK = 2;
	static const jsBool_t printSource = FALSE;

	jsString_t	*names;
	int		namesLength;
	short		argCount;
	short		version;
	jsChar_t	*source;
	int		sourceLength;
	JSNativeFunction
			**nestedFunctions;
	int		nestedFunctionsLength;

    public:
	static	const jsString_t	className;

    protected:
	static	void	finishInit(JSContext *cx, JSScriptable *scope,
				JSFunctionObject *ctor, JSScriptable *proto);
	/* JS methods */
	static	jsVal_t	jsConstructor(JSContext *cx, int numArgs,
				jsVal_t *args, JSFunction *ctorObj,
				jsBool_t inNewExpr);
	static	jsVal_t	jsFunction_toString(JSContext *cx,
				JSScriptable *thisObj, int numArgs,
				jsVal_t *args, JSFunction *funObj);
	static	jsVal_t	jsFunction_apply(JSContext *cx,
				JSScriptable *thisObj, int numArgs,
				jsVal_t *args, JSFunction *funObj);
	static	jsVal_t	jsFunction_call(JSContext *cx,
				JSScriptable *thisObj, int numArgs,
				jsVal_t *args, JSFunction *funObj);
	static	double	longBitsToDouble(int64_t bits);

	jsBool_t
		nextIs(int i, int token);
	JSNativeCall *
		getActivation(JSContext *cx);

    public:
	static	void	defineClass(JSContext *cx, JSScriptable *scope);

	JSNativeFunction();

	/* getter, setter */
	jsBool_t
		jsGet_length(JSContext *cx, jsVal_t *value);
	jsBool_t
		jsGet_arity(JSContext *cx, jsVal_t *value);
	jsBool_t
		jsGet_name(JSContext *cx, jsVal_t *value);

	jsString_t
		decompile(JSContext *cx, int indent, jsBool_t topLevel,
			jsBool_t justBody);
	JSScriptable *
		getClassPrototype(JSContext *cx);

	/* instanceof methods */
	jsBool_t	
		isInstanceOf(const jsString_t className);

	/* scriptable methods */
	jsString_t
		getClassName(JSContext *cx);
	jsBool_t
		has(JSContext *cx, jsString_t name, JSScriptable *start);
	jsBool_t
		get(JSContext *cx, jsString_t name, JSScriptable *start,
			jsVal_t *value);

	jsBool_t
		hasInstance(JSContext *cx, JSScriptable *instance);

	/* function methods */
	jsVal_t	call(JSContext *cx, JSScriptable *scope, JSScriptable *thisObj,
			int numArgs, jsVal_t *args);
	JSScriptable
		*construct(JSContext *cx, JSScriptable *scope, int numArgs,
			jsVal_t *args);

	/* gc methods */
	void	mark(JSContext *cx);
};

#endif /* _JS_NATIVE_FUNCTION_H_ */

